Setting Live ‘DataForSEO Search Volume’ Tasks

This endpoint will provide you with search volume normalized with Bing search volume data or clickstream data for up to 1000 keywords in a single request.

checked POST
Pricing

Your account will be charged for each request.
The cost can be calculated on the Pricing page.

All POST data should be sent in the JSON format (UTF-8 encoding). The task setting is done using the POST method. When setting a task, you should send all task parameters in the task array of the generic POST array. You can send up to 2000 API calls per minute, each Live API call can contain only one task. Visit DataForSEO Help Center to get practical tips for request handling depending on your Keyword Data API payload volume.

You will get information for every single keyword in an array.

Note that you can send no more than 12 requests per minute per account due certain limitations beyond our control.

You can send up to 1000 keywords in one keywords array. Our system will charge your account per each request, no matter what number of keywords an array has, the price for 1 or 1000 keywords will be the same.

Below you will find a detailed description of the fields you can use for setting a task.

Description of the fields for setting a task:

Field nameTypeDescription
keywordsarray

target keywords
required field
UTF-8 encoding
maximum number of keywords you can specify in this array: 1000
the keywords will be converted to lowercase format

Note: certain symbols and characters (e.g., UTF symbols, emojis) are not allowed
to learn more about which symbols and characters can be used, please refer to this article

learn more about rules and limitations of keyword and keywords fields in DataForSEO APIs in this Help Center article

location_namestring

full name of search engine location
required field if you don’t specify location_code
you can receive the list of available locations with location_name by making a separate request to https://api.dataforseo.com/v3/keywords_data/clickstream_data/locations_and_languages
example:
United Kingdom

location_codeinteger

search engine location code
required field if you don’t specify location_name
if you use this field, you can receive the list of available locations with location_code by making a separate request to the https://api.dataforseo.com/v3/keywords_data/clickstream_data/locations_and_languages
example:
2826

language_namestring

full name of search engine language
required field if don’t specify language_code
you can receive the list of available languages with their language_name by making a separate request to the https://api.dataforseo.com/v3/keywords_data/clickstream_data/locations_and_languages
example:
English

language_codestring

search engine language code
required field if don’t specify language_name
you can receive the list of available languages with their language_code by making a separate request to the https://api.dataforseo.com/v3/keywords_data/clickstream_data/locations_and_languages
example:
en

use_clickstreamboolean

use clickstream data to provide results
optional field
if set to true, you will get DataForSEO search volume values based on clickstream data;
if set to false, Bing search volume data will be used to calculate DataForSEO search volume;
default value: true;
Note: Bing search volume is available for locations provided in Bing Search Volume History Locations and Bing Ads Locations endpoints; search volume values for any other location are calculated based on clickstream data even if you set this parameter to false

tagstring

user-defined task identifier
optional field
the character limit is 255
you can use this parameter to identify the task and match it with the result
you will find the specified tag value in the data object of the response



As a response of the API server, you will receive JSON-encoded data containing a tasks array with the information specific to the set tasks.

Description of the fields in the results array:

Field nameTypeDescription
versionstring

the current version of the API

status_codeinteger

general status code
you can find the full list of the response codes here
Note: we strongly recommend designing a necessary system for handling related exceptional or error conditions

status_messagestring

general informational message
you can find the full list of general informational messages here

timestring

execution time, seconds

costfloat

total tasks cost, USD

tasks_countinteger

the number of tasks in the tasks array

tasks_errorinteger

the number of tasks in the tasks array returned with an error

tasksarray

array of tasks

    idstring

task identifier
unique task identifier in our system in the UUID format

    status_codeinteger

status code of the task
generated by DataForSEO; can be within the following range: 10000-60000
you can find the full list of the response codes here

    status_messagestring

informational message of the task
you can find the full list of general informational messages here

    timestring

execution time, seconds

    costfloat

cost of the task, USD

    result_countinteger

number of elements in the result array

    patharray

URL path

    dataarray

contains the same parameters that you specified in the POST request

    resultarray

array of results

        location_codestring

location code in a POST array
if there is no data, then the value is null

        language_codestring

language code in a POST array

Note:if the keyword in the POST array appears to be misspelled, data will be returned for the correctly spelled keyword;
we use the functionality of Google Ads API to check and validate the spelling of keywords, learn more by this link

        location_codeinteger

location code in a POST array
if there is no data, then the value is_nulln

        language_codestring

language code in a POST array
if there is no data, then the value is_nulln

        items_countstring

ithe number of results returned in the items array

        itemsarray

array of keywords
contains keywords and their search volume rates

            keywordstring

keyword provided in the POST array

            use_clickstreamboolean

indicates if the use_clickstream parameter is active
possible values: true, false

            search_volumeinteger

current search volume rate of a keyword

            monthly_searchesarray

monthly search volume rates
array of objects with search volume rates in a certain month of a year

                yearinteger

year

                monthinteger

month

                search_volumeinteger

search volume rate in a certain month of a year

‌‌

Instead of ‘login’ and ‘password’ use your credentials from https://app.dataforseo.com/api-access

# Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access 
login="login" 
password="password" 
cred="$(printf ${login}:${password} | base64)" 
curl --location --request POST "https://api.dataforseo.com/v3/keywords_data/clickstream_data/dataforseo_search_volume/live" 
--header "Authorization: Basic ${cred}"  
--header "Content-Type: application/json" 
--data-raw '[
  {
    "location_code": 2840,
    "language_code": "en",
    "tag": "test-tag",
    "keywords": [
      "you tube",
      "youtube",
      "youtub"
    ]
  }
]'
<?php
// You can download this file from here https://cdn.dataforseo.com/v3/examples/php/php_RestClient.zip
require('RestClient.php');
$api_url = 'https://api.dataforseo.com/';
// Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
$client = new RestClient($api_url, null, 'login', 'password');

$post_array = array();
// simple way to set a task
$post_array[] = array(
	"keywords" => [
        "you tube",
        "youtube",
        "youtub"
	],
	"language_name" => "English",
	"location_code" => 2840
);
try {
	// POST /v3/keywords_data/clickstream_data/dataforseo_search_volume/live
	$result = $client->post('/v3/keywords_data/clickstream_data/dataforseo_search_volume/live', $post_array);
	print_r($result);
	// do something with post result
} catch (RestClientException $e) {
	echo "n";
	print "HTTP code: {$e->getHttpCode()}n";
	print "Error code: {$e->getCode()}n";
	print "Message: {$e->getMessage()}n";
	print  $e->getTraceAsString();
	echo "n";
}
$client = null;
?>
var request = require('request');
var options = {
  'method': 'POST',
  'url': 'https://api.dataforseo.com/v3/keywords_data/clickstream_data/dataforseo_search_volume/live',
  'headers': {
    'Authorization': 'Basic c3VwcG9ydEBkYXRhZm9yc2VvLmNvbTpTUnJYVHp2UGtFSjgzdXlz',
    'Content-Type': 'application/json',
    'User-Agent': 'test'
  },
  body: JSON.stringify([
    {
      "location_code": 2840,
      "language_code": "en",
      "tag": "test-tag",
      "keywords": [
        "you tube",
        "youtube",
        "youtub"
      ]
    }
  ])

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
from client import RestClient
# You can download this file from here https://cdn.dataforseo.com/v3/examples/python/python_Client.zip
client = RestClient("login", "password")
post_data = dict()
# simple way to set a task
post_data[len(post_data)] = dict(
    keywords=[
        "you tube",
        "youtube",
        "youtub"
    ],
    location_name="United States",
    language_name="English"
)
# POST /v3/keywords_data/clickstream_data/dataforseo_search_volume/live
response = client.post("/v3/keywords_data/clickstream_data/dataforseo_search_volume/live", post_data)
# you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
if response["status_code"] == 20000:
    print(response)
    # do something with result
else:
    print("error. Code: %d Message: %s" % (response["status_code"], response["status_message"]))
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;

namespace DataForSeoDemos
{
    public static partial class Demos
    {
        public static async Task keywords_data_clickstream_data_dataforseo_search_volume_live()
        {
            var httpClient = new HttpClient
            {
                BaseAddress = new Uri("https://api.dataforseo.com/"),
                // Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
                DefaultRequestHeaders = { Authorization = new AuthenticationHeaderValue("Basic", Convert.ToBase64String(Encoding.ASCII.GetBytes("login:password"))) }
            };
            var postData = new List<object>();
            postData.Add(new
            {
                keywords = new[]
                {
                    "you tube",
                    "youtube",
                    "youtub"
                },
                location_name = "United States",
                language_name = "English"
            });
            // POST /v3/keywords_data/clickstream_data/dataforseo_search_volume/live
            // the full list of possible parameters is available in documentation

            var taskPostResponse = await httpClient.PostAsync("/v3/keywords_data/clickstream_data/dataforseo_search_volume/live", new StringContent(JsonConvert.SerializeObject(postData)));
            var result = JsonConvert.DeserializeObject<dynamic>(await taskPostResponse.Content.ReadAsStringAsync());
            // you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
            if (result.status_code == 20000)
            {
                // do something with result
                Console.WriteLine(result);
            }
            else
                Console.WriteLine($"error. Code: {result.status_code} Message: {result.status_message}");
        }
    }
}

The above command returns JSON structured like this:

{
  "version": "0.1.20240801",
  "status_code": 20000,
  "status_message": "Ok.",
  "time": "3.6964 sec.",
  "cost": 0.15,
  "tasks_count": 1,
  "tasks_error": 0,
  "tasks": [
    {
      "id": "08021312-1535-0589-0000-c36efd4ad04e",
      "status_code": 20000,
      "status_message": "Ok.",
      "time": "3.6322 sec.",
      "cost": 0.15,
      "result_count": 1,
      "path": [
        "v3",
        "keywords_data",
        "clickstream_data",
        "dataforseo_search_volume",
        "live"
      ],
      "data": {
        "api": "keywords_data",
        "function": "dataforseo_search_volume",
        "se": "clickstream_data",
        "location_code": 2840,
        "language_code": "en",
        "use_clickstream": true,
        "tag": "test-tag",
        "keywords": [
          "you tube",
          "youtube",
          "youtub"
        ]
      },
      "result": [
        {
          "location_code": 2840,
          "language_code": "en",
          "items_count": 3,
          "items": [
            {
              "keyword": "you tube",
              "use_clickstream": true,
              "search_volume": 3841450,
              "monthly_searches": [
                {
                  "year": 2024,
                  "month": 6,
                  "search_volume": 4850027
                },
                {
                  "year": 2024,
                  "month": 5,
                  "search_volume": 5791200
                },
                {
                  "year": 2024,
                  "month": 4,
                  "search_volume": 5063908
                },
                {
                  "year": 2024,
                  "month": 3,
                  "search_volume": 4057639
                },
                {
                  "year": 2024,
                  "month": 2,
                  "search_volume": 3499745
                },
                {
                  "year": 2024,
                  "month": 1,
                  "search_volume": 4948844
                },
                {
                  "year": 2023,
                  "month": 12,
                  "search_volume": 4167276
                },
                {
                  "year": 2023,
                  "month": 11,
                  "search_volume": 3252548
                },
                {
                  "year": 2023,
                  "month": 10,
                  "search_volume": 4372437
                },
                {
                  "year": 2023,
                  "month": 9,
                  "search_volume": 3322543
                },
                {
                  "year": 2023,
                  "month": 8,
                  "search_volume": 4070665
                },
                {
                  "year": 2023,
                  "month": 7,
                  "search_volume": 3424434
                }
              ]
            },
            {
              "keyword": "youtube",
              "use_clickstream": true,
              "search_volume": 141457261,
              "monthly_searches": [
                {
                  "year": 2024,
                  "month": 6,
                  "search_volume": 161581931
                },
                {
                  "year": 2024,
                  "month": 5,
                  "search_volume": 200944345
                },
                {
                  "year": 2024,
                  "month": 4,
                  "search_volume": 189930752
                },
                {
                  "year": 2024,
                  "month": 3,
                  "search_volume": 167179529
                },
                {
                  "year": 2024,
                  "month": 2,
                  "search_volume": 131840294
                },
                {
                  "year": 2024,
                  "month": 1,
                  "search_volume": 186755632
                },
                {
                  "year": 2023,
                  "month": 12,
                  "search_volume": 179034394
                },
                {
                  "year": 2023,
                  "month": 11,
                  "search_volume": 144365840
                },
                {
                  "year": 2023,
                  "month": 10,
                  "search_volume": 185597392
                },
                {
                  "year": 2023,
                  "month": 9,
                  "search_volume": 143876762
                },
                {
                  "year": 2023,
                  "month": 8,
                  "search_volume": 171954692
                },
                {
                  "year": 2023,
                  "month": 7,
                  "search_volume": 131361848
                }
              ]
            },
            {
              "keyword": "youtub",
              "use_clickstream": true,
              "search_volume": 401067,
              "monthly_searches": [
                {
                  "year": 2024,
                  "month": 6,
                  "search_volume": 456295
                },
                {
                  "year": 2024,
                  "month": 5,
                  "search_volume": 560123
                },
                {
                  "year": 2024,
                  "month": 4,
                  "search_volume": 557952
                },
                {
                  "year": 2024,
                  "month": 3,
                  "search_volume": 517788
                },
                {
                  "year": 2024,
                  "month": 2,
                  "search_volume": 368580
                },
                {
                  "year": 2024,
                  "month": 1,
                  "search_volume": 536242
                },
                {
                  "year": 2023,
                  "month": 12,
                  "search_volume": 529729
                },
                {
                  "year": 2023,
                  "month": 11,
                  "search_volume": 393389
                },
                {
                  "year": 2023,
                  "month": 10,
                  "search_volume": 513446
                },
                {
                  "year": 2023,
                  "month": 9,
                  "search_volume": 388073
                },
                {
                  "year": 2023,
                  "month": 8,
                  "search_volume": 383185
                },
                {
                  "year": 2023,
                  "month": 7,
                  "search_volume": 329596
                }
              ]
            }
          ]
        }
      ]
    }
  ]
}